<script lang="ts">
    import { onMount } from 'svelte';
    import { Card } from 'flowbite-svelte';
    import Prism from 'prismjs';
    import 'prismjs/components/prism-hcl';
    import 'prismjs/themes/prism-tomorrow.css';
    
    export let data;
    let content = '';
    let loading = true;
    let error = '';
    let codeElement: HTMLElement;
    let prismInitialized = false;

    function getLanguageFromPath(path: string): string {
        const extension = path.split('.').pop()?.toLowerCase() || '';
        const languageMap: Record<string, string> = {
            'tf': 'hcl',
            'tfvars': 'hcl',
            'hcl': 'hcl'
        };
        return languageMap[extension] || 'plaintext';
    }

    function ensurePrismInitialized() {
        if (!prismInitialized) {
            // Force Prism to initialize languages
            if (typeof Prism.highlightAll === 'function') {
                Prism.manual = true;
                prismInitialized = true;
            }
        }
    }

    function applyHighlighting() {
        if (content && codeElement && Prism.languages.hcl) {
            try {
                const highlighted = Prism.highlight(
                    content,
                    Prism.languages.hcl,
                    'hcl'
                );
                codeElement.innerHTML = highlighted;
            } catch (e) {
                console.error('Highlighting failed:', e);
                // Fallback to raw content if highlighting fails
                codeElement.textContent = content;
            }
        }
    }

    async function loadContent() {
        try {
            loading = true;
            ensurePrismInitialized();
            
            const response = await fetch(`/${data.path}`);
            if (!response.ok) {
                throw new Error('Failed to load file');
            }
            
            const text = await response.text();
            content = text;

            // Wait for a proper DOM update
            await new Promise(resolve => setTimeout(resolve, 50));
            applyHighlighting();
            
        } catch (e) {
            error = e instanceof Error ? e.message : 'Error loading file';
            console.error('Error loading file:', e);
        } finally {
            loading = false;
        }
    }

    onMount(() => {
        ensurePrismInitialized();
        loadContent();
    });

    // Re-apply highlighting if the code element changes
    $: if (codeElement && content && !loading) {
        applyHighlighting();
    }

    $: fileType = getLanguageFromPath(data.path);
</script>

<div class="w-full px-4 py-8">
    <Card class="!w-full !max-w-none">
        <div class="flex justify-between items-center mb-4">
            <h1 class="text-xl font-semibold break-all">{data.path}</h1>
            <div class="flex gap-4 shrink-0">
                <button 
                    class="text-blue-600 hover:text-blue-800"
                    on:click={() => history.back()}
                >
                    ← Back
                </button>
                <a 
                    href="/{data.path}" 
                    class="text-blue-600 hover:text-blue-800"
                    download
                >
                    Download
                </a>
            </div>
        </div>

        {#if loading}
            <div class="p-4 text-gray-600">Loading file content...</div>
        {:else if error}
            <div class="p-4 text-red-600">
                Error: {error}
            </div>
        {:else}
            <div class="relative">
                <pre class="rounded-lg overflow-x-auto">
                    <code 
                        class="language-{fileType}" 
                        bind:this={codeElement}
                    >{content}</code>
                </pre>
            </div>
        {/if}
    </Card>
</div>

<style>
    /* Code block container */
    pre {
        margin: 0;
        padding: 1.5rem;
        background-color: #2d2d2d !important;
        border-radius: 0.5rem;
        overflow-x: auto;
        min-height: 100px;
    }

    /* Code text */
    code {
        font-family: ui-monospace, SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace;
        font-size: 0.9em;
        line-height: 1.5;
        color: #e5e7eb;
        white-space: pre;
    }

    /* Ensure Prism styles don't conflict */
    :global(pre[class*="language-"]) {
        margin: 0;
        background: #2d2d2d;
        white-space: pre;
    }

    :global(pre[class*="language-"] code) {
        text-shadow: none;
    }

    /* HCL specific token colors */
    :global(.token.block-expression) {
        color: #89ddff !important;
    }

    :global(.token.resource) {
        color: #c3e88d !important;
    }

    :global(.token.property) {
        color: #f78c6c !important;
    }

    :global(.token.string) {
        color: #c3e88d !important;
    }

    :global(.token.number) {
        color: #f78c6c !important;
    }

    :global(.token.comment) {
        color: #676e95 !important;
        font-style: italic;
    }

    :global(.token.keyword) {
        color: #c792ea !important;
    }

    :global(.token.punctuation) {
        color: #89ddff !important;
    }
</style>